package io.getquill.norm.select

import scala.reflect.macros.whitebox.Context

import io.getquill.ast.Ast
import io.getquill.ast.Query
import io.getquill.context.EncodingMacro

trait SelectFlattening extends EncodingMacro {
  val c: Context

  import c.universe._

  protected def flattenSelect(q: Query, tpe: Type, inferDecoder: Type => Option[Tree]) = {
    val (query, mapAst) = ExtractSelect(q)
    val selectValues = encoding(mapAst, tpe, inferDecoder)
    (ReplaceSelect(query, selectAsts(selectValues)), selectValues)
  }

  private def selectAsts(value: Value): List[Ast] =
    value match {
      case SimpleValue(ast, _, _)    => List(ast)
      case CaseClassValue(_, params) => params.flatten.map(selectAsts).flatten
      case OptionValue(value)        => selectAsts(value)
    }
}
